package de.avatic.taric.serializer;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import de.avatic.taric.model.Footnote;
import de.avatic.taric.repository.FootnoteRepository;
import org.springframework.data.jdbc.core.mapping.AggregateReference;
import org.springframework.stereotype.Component;

import java.io.IOException;

@Component
public class FootnoteReferenceSerializer extends JsonSerializer<AggregateReference<Footnote, Integer>> {

    protected final FootnoteRepository footnoteRepository;

    public FootnoteReferenceSerializer(FootnoteRepository footnoteRepository) {
        this.footnoteRepository = footnoteRepository;
    }

    @Override
    public void serialize(AggregateReference<Footnote, Integer> value, JsonGenerator gen,
                          SerializerProvider serializers) throws IOException {
        if (value != null) {
            Footnote footnote = footnoteRepository.findById(value.getId())
                    .orElse(null);

            gen.writeObject(footnote);
        } else {
            gen.writeNull();
        }
    }
}
